from matplotlib.figure import Figure
from matplotlib.backends.backend_qt4agg import (
    FigureCanvasQTAgg as FigureCanvas,
    NavigationToolbar2QT as NavigationToolbar)
import pandas as pd






from numpy import *
from PyQt4.QtGui import QTextEdit





def estadistiques(self,assignatura,curs):
    df = pd.read_csv('final2.csv')
    df = df[df['ANY']==curs]
    #estadistiques sele
    if assignatura=='SELE':
        x = df[df['SELE']>9]
        x = x.describe()
        x = x['SELE']
        l=['alumnes: '+str(x[0]), 'mitjana: '+str(x[1]),'desviacio: '+str(x[2]), 'min: '+str(x[3]),'25%: '+str(x[4]),'50%: '+str(x[5]),'75%: '+str(x[6]),'max: '+str(x[7])]
        s=assignatura
        for e in l:
            s = s + '\n' + e
    

    else:
        x = df[df[assignatura]!=-1]
        x = x[x['SELE']>9]
        x = x[assignatura].describe()
        l=['alumnes: '+str(x[0]), 'mitjana: '+str(x[1]),'desviacio: '+str(x[2]), 'min: '+str(x[3]),'25%: '+str(x[4]),'50%: '+str(x[5]),'75%: '+str(x[6]),'max: '+str(x[7])]
        s=assignatura
        for e in l:
            s = s + '\n' + e
            
    clean_layout(self.ui.graficlayout)
    fig = QTextEdit()
    fig.setText(s)
    self.ui.graficlayout.addWidget(fig)

def clean_layout(layout):
        for i in reversed(range(layout.count())):
            layout.itemAt(i).widget().setParent(None)




    


    
def rectaregressio(assig,curs):
    df = pd.read_csv('final2.csv')
    df = df[df['SELE']>9]
    df = df[df['ANY'] == curs]

    data = df[df[assig]!=-1]
    data = data['SELE']
    data2 = df[df[assig]!=-1]
    data2 = data2[assig]
    recta = polyfit(data,data2,1)
    
    n = ''
    for e in str(recta[0]):
        if len(n)<5:
            n = n + str(e)
    m = ''
    for i in str(recta[1]):
        if len(m)<5:
            m = m + str(i)
    recta = [m,n]
     
    
    return recta
        
def addmpl(self, assig,curs):
    clean_layout(self.ui.graficlayout)
    df = pd.read_csv('final2.csv')
    x = df[df[assig]!=-1]
    x = x[x['SELE']>9]
    fig = Figure()
    ax1f1 = fig.add_subplot(111)
    ax1f1.plot(x['SELE'], x[assig],'o')
    ax1f1.set_ylabel(assig)
    ax1f1.set_xlabel('nota acces')
    self.ui.canvas = FigureCanvas(fig)
    self.ui.graficlayout.addWidget(self.ui.canvas)
    self.ui.canvas.draw()
    regressio = rectaregressio(assig,curs)
    text = str(regressio[0])+' '+'+'+' ' + str(regressio[1])+'*'+'X'
    recta = QTextEdit()
    recta.setText(text)
    self.ui.graficlayout.addWidget(recta)
    
def aprovats(self,curs):
    f = open('final2.csv','r')
    aprova0 = 0
    aprova1 = 0
    aprova2 = 0
    aprova3 = 0
    aprova4 = 0
    aprova5 = 0
    aprova6 = 0
    aprova7 = 0
    aprova8 = 0
    aprova9 = 0
    aprova10 = 0
    
    for e in f:
        e = e.strip()
        s = e.split(',')
        if s[0]!='CODEX' and float(s[2]) == curs:
            n = 0
            for i in range(4,14):
                if float(s[i])>5:
                    n = n + 1
            if n == 0:
                aprova0 +=1
            if n == 1:
                aprova1 +=1
            if n == 2:
                aprova2 +=1
            if n == 3:
                aprova3 +=1
            if n == 4:
                aprova4 +=1
            if n == 5:
                aprova5 +=1
            if n == 6:
                aprova6 +=1
            if n == 7:
                aprova7 +=1
            if n == 8:
                aprova8 +=1
            if n == 9:
                aprova9 +=1
            if n == 10:
                aprova10 +=1
    
    A = [aprova0]
    B = [aprova1]
    C = [aprova2]
    D = [aprova3]
    E = [aprova4]
    F = [aprova5]
    G = [aprova6]
    H = [aprova7]
    I = [aprova8]
    J = [aprova9]
    K = [aprova10]
    
    
   
    
    clean_layout(self.ui.graficlayout)

    fig = Figure()

    g = fig.add_subplot(111)
    g.bar(0, A, color = '#DA5252',width = 1)
    g.bar(1, B, color = '#B21E1E' ,width = 1)
    g.bar(2, C, color = '#E10909',width = 1)
    g.bar(3, D, color = '#DA5252',width = 1)
    g.bar(4, E, color = '#B21E1E' ,width = 1)
    g.bar(5, F, color = '#E10909',width = 1)
    g.bar(6, G, color = '#DA5252',width = 1)
    g.bar(7, H, color = '#B21E1E' ,width = 1)
    g.bar(8, I, color = '#E10909',width = 1)
    g.bar(9, J, color = '#E10909',width = 1)
    g.bar(10, K, color = '#E10909',width = 1)
    g.set_xlabel(curs)
    self.ui.canvas = FigureCanvas(fig)
    self.ui.graficlayout.addWidget(self.ui.canvas)
    self.ui.canvas.draw()
               
    
def estima(self,nmin,nmax):
    df = pd.read_csv('final2.csv')
    df = df[df['SELE']>nmin]
    df = df[df['SELE']<nmax]
    
    calcul = df[df['CAL']!=-1]
    calcul = calcul['CAL'].mean()
    
    scalcul = ''
    for e in str(calcul):
        if len(scalcul)<4:
            scalcul = scalcul + str(e)
    
    quimica = df[df['QUI']!=-1]
    quimica = quimica['QUI'].mean()
    
    squimica = ''
    for e in str(quimica):
        if len(squimica)<4:
            squimica = squimica + str(e)
    
    algebra = df[df['ALG']!=-1]
    algebra = algebra['ALG'].mean()
    
    salgebra = ''
    for e in str(algebra):
        if len(salgebra)<4:
            salgebra = salgebra + str(e)
    
    info = df[df['INF']!=-1]
    info = info['INF'].mean()
    
    sinfo = ''
    for e in str(info):
        if len(sinfo)<4:
            sinfo = sinfo + str(e)
    
    mecanica = df[df['MEC']!=-1]
    mecanica = mecanica['MEC'].mean()
    
    smecanica = ''
    for e in str(mecanica):
        if len(smecanica)<4:
            smecanica = smecanica + str(e)
    
    quimica2 = df[df['QUI2']!=-1]
    quimica2 = quimica2['QUI2'].mean()
    
    squimica2 = ''
    for e in str(quimica2):
        if len(squimica2)<4:
            squimica2 = squimica2 + str(e)
    
    calcul2 = df[df['CAL2']!=-1]
    calcul2 = calcul2['CAL2'].mean()
    
    scalcul2 = ''
    for e in str(calcul2):
        if len(scalcul2)<4:
            scalcul2 = scalcul2 + str(e)
    
    geo = df[df['GEO']!=-1]
    geo = geo['GEO'].mean()
    
    sgeo = ''
    for e in str(geo):
        if len(sgeo)<4:
            sgeo = sgeo + str(e)
    
    termo = df[df['TER']!=-1]
    termo = termo['TER'].mean()
    
    stermo = ''
    for e in str(termo):
        if len(stermo)<4:
            stermo = stermo + str(e)
    
    expre = df[df['EXP']!=-1]
    expre = expre['EXP'].mean()
    
    sexpre = ''
    for e in str(expre):
        if len(sexpre)<4:
            sexpre = sexpre + str(e)
        
    s = 'Nota acces entre '+str(nmin)+' i '+str(nmax) + '\n' + '\n'
    s = s + 'Calcul ' + scalcul + '\n'
    s = s + 'Quimica ' + squimica + '\n'
    s = s + 'Mecanica ' + smecanica + '\n'
    s = s + 'Informatica ' + sinfo + '\n'
    s = s + 'Algebra ' + salgebra + '\n'
    s = s + 'Quimica2 ' + squimica2 + '\n'
    s = s + 'Calcul2 ' + scalcul2 + '\n'
    s = s + 'Geometria ' +sgeo + '\n'
    s = s + 'Termodinamica ' + stermo + '\n'
    s = s + 'Expressio grafica ' +sexpre + '\n'
    
    clean_layout(self.ui.graficlayout)
    notes = QTextEdit()
    notes.setText(s)
    self.ui.graficlayout.addWidget(notes)
    
